<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "nppes_data_validation_form".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "NppesDataValidationForm".
 *
 * Columns in table "nppes_data_validation_form" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property string $first_name
 * @property string $last_name
 * @property string $npi_id
 * @property string $country_of_birth
 * @property string $state_of_birth
 * @property string $dob
 * @property string $date_sent
 * @property string $date_added
 *
 */
abstract class BaseNppesDataValidationForm extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'nppes_data_validation_form';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'NppesDataValidationForm|NppesDataValidationForms', $n);
    }

    public static function representingColumn()
    {
        return 'first_name';
    }

    public function rules()
    {
        return array(
            array('first_name, last_name, npi_id, country_of_birth, dob', 'required'),
            array('first_name, country_of_birth, state_of_birth', 'length', 'max' => 50),
            array('last_name', 'length', 'max' => 80),
            array('npi_id', 'length', 'max' => 10),
            array('date_sent, date_added', 'safe'),
            array('state_of_birth, date_sent, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, first_name, last_name, npi_id, country_of_birth, state_of_birth, dob, date_sent, date_added',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array();
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'npi_id' => Yii::t('app', 'Npi'),
            'country_of_birth' => Yii::t('app', 'Country Of Birth'),
            'state_of_birth' => Yii::t('app', 'State Of Birth'),
            'dob' => Yii::t('app', 'Dob'),
            'date_sent' => Yii::t('app', 'Date Sent'),
            'date_added' => Yii::t('app', 'Date Added'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('npi_id', $this->npi_id, true);
        $criteria->compare('country_of_birth', $this->country_of_birth, true);
        $criteria->compare('state_of_birth', $this->state_of_birth, true);
        $criteria->compare('dob', $this->dob, true);
        $criteria->compare('date_sent', $this->date_sent, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array('criteria' => $criteria, 'pagination' => array('pageSize' => 100)));
    }

}
